VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cPOSHeader"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"3D3D1A730302"
'<CAMH>****************************************************************************************
'* Module: cPOSHeader
'* Date  : 09/08/02
'* Author: mauricem
'*$Archive: /Projects/OasysV2/VB/SalesBO/POSInvoice.cls $
'**********************************************************************************************
'* Summary: Business Object to wrap the functionality of the Till Sales Slip
'**********************************************************************************************
'* $Author: Richardc $ $Date: 3/06/04 9:42 $ $Revision: 14 $
'* Versions:
'* 09/08/02    mauricem
'*             Header added.
'* 07/06/07    mikeo'c
'*             Card Number field added for WIX1311 Discount Cards
'</CAMH>***************************************************************************************
Option Base 0
Option Explicit

Const MODULE_NAME As String = "cPOSHeader"
Const PRM_TRANSNO As Integer = 910

Implements IBo
Implements ISysBo

' Certain methods require that specific properties have been loaded.
' This dictionary holds FIDs that have been loaded so we can check.
Private m_dicFidsLoaded As Dictionary

'##ModelId=3D45432E03B6
Private mTranDate As Date

'##ModelId=3D4544D70276
Private mTillID As String

'##ModelId=3D4544EE01A4
Private mTransactionNo As String

'##ModelId=3D4544F503B6
Private mCashierID As String

'##ModelId=3D4544FE03C0
Private mTransactionTime As Date

'##ModelId=3D45451002BC
Private mTransactionCode As String

'##ModelId=3D45451F01D6
Private mOpenDrawerCode As Long

'##ModelId=3D4545370172
Private mReasonCode As Long

'##ModelId=3D4545440258
Private mOrderNumber As String

'##ModelId=3D45454D003C
Private mVoided As Boolean

'##ModelId=3D4545560154
Private mTrainingMode As Boolean

'##ModelId=3D45455D0096
Private mDailyUpdateProc As Boolean

'##ModelId=3D45456D00BE
Private mTranParked As Boolean

'##ModelId=3D454583010E
Private mSupervisorNo As String

'##ModelId=3D454589032A
Private mSupervisorUsed As Boolean

'##ModelId=3D4545940352
Private mVoidSupervisor As String

'##ModelId=3D45459B01B8
Private mDiscountSupervisor As String

'##ModelId=3D4545A403AC
Private mMerchandiseAmount As Currency

'##ModelId=3D4545B90172
Private mNonMerchandiseAmount As Currency

'##ModelId=3D4545C601C2
Private mTaxAmount As Currency

'##ModelId=3D4545CD0212
Private mDiscountAmount As Currency

'##ModelId=3D4545D201D6
Private mTotalSaleAmount As Currency

'##ModelId=3D4545D9030C
Private mVATRates(9) As Double

'##ModelId=3D4545DE0262
Private mVATSymbol(9) As String

'##ModelId=3D4545E70082
Private mExVATValue(9) As Double

'##ModelId=3D4545EE02F8
Private mVATValue(9) As Double

'##ModelId=3D45462F02A8
Private mTransactionComplete As Boolean

Private mCustomerAcctNo As String
Private mCustomerAcctCardNo As String
Private mCollectPostCode As Boolean
Private mFromDCOrders As Boolean
Private mEmployeeDiscountOnly As Boolean
Private mRefundCashier As String
Private mRefundSupervisor As String
Private mRefundManager As String
Private mTenderOverrideCode As String
Private mRecoveredFromParked As Boolean
Private mOffline As Boolean
Private mGiftTokensPrinted As Long
Private mDescription As String
Private mAccountSale As Boolean
Private mExternalDocumentNo As String
Private mStoreNumber As String
Private mColleagueCardNo As String
Private mDiscountCardNumber As String
Private mSource As String
Private mReceiptBarcode As String


Private mSaveStatus As String
Private mSaveSequenceNo As String

Private mblnOnlineUpdate As Boolean 'used for updates from Offline Transactions -does not allocate Tran ID

Private mblnNewCustomer As Boolean

Private mblnNewPPCustomer As Boolean

Private mcolLines    As Collection

Private mcolOPLines  As Collection

Private mcolPayments As Collection

Private mcolPaymentComms As Collection

Private mcolPricePromise As Collection

Private mcolGiftVouchers As Collection

Private mcolEANChecks    As Collection
Private mcolOfflineEANChecks    As Collection 'used to hold Offline EAN checks for adding to history File
Private mcolPromptRejects   As Collection 'used to hold Prompt Rejects to add to History Text File

Private mcolSoldCoupons As Collection 'WIX1165 - store sold coupons

Private moPPCust  As cPriceCusInfo

Private moCustomer As cReturnCust

Private moRowSel As IRowSelector

Private moLoadRow As IRowSelector

Private m_oSession As Session

Private mSaveFailedStatus As String
    
Public Property Get Customer() As cReturnCust

    If moCustomer Is Nothing Then
        Set moCustomer = m_oSession.Database.CreateBusinessObject(CLASSID_RETURNCUST)
        Call moCustomer.AddLoadFilter(CMP_EQUAL, FID_RETURNCUST_PCTillID, mTillID)
        Call moCustomer.AddLoadFilter(CMP_EQUAL, FID_RETURNCUST_TransactionNumber, mTransactionNo)
        Call moCustomer.AddLoadFilter(CMP_EQUAL, FID_RETURNCUST_TransactionDate, mTranDate)
        Call moCustomer.LoadMatches
        Set Customer = moCustomer
    Else
        Set Customer = moCustomer
    End If
    
End Property

Public Function SetCustomer(strCustomerName) As cReturnCust

    If moCustomer Is Nothing Then
        Set moCustomer = m_oSession.Database.CreateBusinessObject(CLASSID_RETURNCUST)
        mblnNewCustomer = True
    End If
            
    moCustomer.CustomerName = strCustomerName
    moCustomer.TransactionDate = mTranDate
    moCustomer.TransactionNumber = TransactionNo
    moCustomer.PCTillID = mTillID
    Set SetCustomer = moCustomer

End Function
Public Function AddPricePromiseLine(ByVal lngTranLineNo As Long) As cPriceLineInfo

Dim oLine As cPriceLineInfo
Dim lngNo As Long

    If mcolPricePromise Is Nothing Then Set mcolPricePromise = New Collection
    If (mcolPricePromise.Count > 0) Then
        For lngNo = 1 To mcolPricePromise.Count Step 1
            If (mcolPricePromise(lngNo).SequenceNo = lngTranLineNo) Then
                Set oLine = mcolPricePromise(lngNo)
                Exit For
            End If
        Next lngNo
    End If
    
    If ((oLine Is Nothing) = True) Then
        Set oLine = m_oSession.Database.CreateBusinessObject(CLASSID_PRICELINEINFO)
        Call mcolPricePromise.Add(oLine)
    End If
    
    oLine.SequenceNo = lngTranLineNo
    oLine.TranDate = mTranDate
    oLine.TillID = mTillID
    oLine.TransactionNo = mTransactionNo
    Set AddPricePromiseLine = oLine

End Function 'AddPricePromiseLine

Public Function AddPricePromiseCust(strCustomerName As String) As cPriceCusInfo

    If (moPPCust Is Nothing) Then
        Set moPPCust = m_oSession.Database.CreateBusinessObject(CLASSID_PRICECUSINFO)
        mblnNewPPCustomer = True
    End If
    
    moPPCust.TranDate = mTranDate
    moPPCust.Till = mTillID
    moPPCust.Tran = mTransactionNo
    
    moPPCust.Name = strCustomerName
    Set AddPricePromiseCust = moPPCust
        
End Function 'AddPricePromiseCust

Public Function AddEventItem(ByVal lngTranLineNo As Long) As cEventTranLine

Dim oLine       As cEventTranLine
Dim lngEventNo  As Long
Dim lngSeqNo    As Long

    Set oLine = m_oSession.Database.CreateBusinessObject(CLASSID_POSEVENTLINE)
    'oLine.PartCode = PartCode
    
    lngSeqNo = 0
    If mcolOPLines Is Nothing Then
        Set mcolOPLines = New Collection
    Else
        'step through lines and check if other Events on Line
        For lngEventNo = 1 To mcolOPLines.Count Step 1
            If (mcolOPLines(lngEventNo).TranDate = mTranDate) And (mcolOPLines(lngEventNo).TillID = mTillID) And _
                 (mcolOPLines(lngEventNo).TransactionNo = mTransactionNo) And (mcolOPLines(lngEventNo).TransactionLineNo = lngTranLineNo) Then
                'other line found so get latest sequence number
                If lngSeqNo < mcolOPLines(lngEventNo).EventSeqNo Then lngSeqNo = mcolOPLines(lngEventNo).EventSeqNo
            End If
        Next lngEventNo
    End If
    
    'increment sequence number to next position
    lngSeqNo = lngSeqNo + 1
    
    'add event to collection
    Call mcolOPLines.Add(oLine)
    
    'Set generice values to reference header
    oLine.TranDate = mTranDate
    oLine.TillID = mTillID
    oLine.TransactionNo = mTransactionNo
    oLine.TransactionLineNo = lngTranLineNo
    oLine.EventSeqNo = Format$(lngSeqNo, "000000")
    
    'Pass out Event Line for further property settings
    Set AddEventItem = oLine

End Function

'##ModelId=3D3D1B2F037A
Public Function AddItem(PartCode As String) As cPOSLine

Dim oLine As cPOSLine

    Set oLine = m_oSession.Database.CreateBusinessObject(CLASSID_POSLINE)
    Set oLine.POSHeader = Me
    oLine.PartCode = PartCode
    
    If mcolLines Is Nothing Then Set mcolLines = New Collection
    Call mcolLines.Add(oLine)
    oLine.SequenceNo = mcolLines.Count
    oLine.TranDate = mTranDate
    oLine.TillID = mTillID
    oLine.TransactionNumber = mTransactionNo
    oLine.ApplyToStock = True
    Set AddItem = oLine

End Function

Public Function AddKeyedAudit(strReasonCode As String, strEnteredValue As String, strSKU As String) As cEANCheck

Dim oEANCheckBO As cEANCheck

    Set oEANCheckBO = m_oSession.Database.CreateBusinessObject(CLASSID_EAN_CHECK)
    Set oEANCheckBO.POSHeader = Me
    oEANCheckBO.EnteredValue = strEnteredValue
    oEANCheckBO.CorrectSKU = strSKU
    oEANCheckBO.ReasonCode = strReasonCode
    oEANCheckBO.EntryMethod = "Keyed"
    
    If mcolEANChecks Is Nothing Then Set mcolEANChecks = New Collection
    Call mcolEANChecks.Add(oEANCheckBO)
    oEANCheckBO.SequenceNo = mcolEANChecks.Count
    oEANCheckBO.TranDate = mTranDate
    oEANCheckBO.TranTillID = mTillID
    oEANCheckBO.TranNo = mTransactionNo
    oEANCheckBO.TranTime = Format(Now, "HHNN")
    oEANCheckBO.UserID = mCashierID
    
    Set AddKeyedAudit = oEANCheckBO

End Function

Public Sub AddOfflineEANCheck(ByRef oEANCheckBO As cEANCheck)

    Set oEANCheckBO.POSHeader = Me
    
    If mcolOfflineEANChecks Is Nothing Then Set mcolOfflineEANChecks = New Collection
    Call mcolOfflineEANChecks.Add(oEANCheckBO)

End Sub

Public Function AddPayment(PaymentType As Long, PaymentAmount As Double) As cPOSPayment

Dim oPmt As cPOSPayment

    Set oPmt = m_oSession.Database.CreateBusinessObject(CLASSID_POSPAYMENT)
    Set oPmt.POSHeader = Me
    oPmt.TenderType = PaymentType
    oPmt.TenderAmount = PaymentAmount
    oPmt.TransactionDate = mTranDate
    oPmt.TillID = mTillID
    oPmt.TransactionNumber = mTransactionNo
    oPmt.EFTPOSCommsDone = True
    
    If (PaymentType = TENTYPE_GIFTCARD) Then
        oPmt.GCTenderAmount = PaymentAmount
    End If
    
    If mcolPayments Is Nothing Then Set mcolPayments = New Collection
    Call mcolPayments.Add(oPmt)
    oPmt.SequenceNumber = mcolPayments.Count
    Set AddPayment = oPmt

End Function

Public Function AddCoupon(CouponID As String, Status As String, ExcCoupon As Boolean, _
                MarketRef As String, SerialNo As String) As cSoldCoupon

Dim oCoupon As cSoldCoupon

    If mcolSoldCoupons Is Nothing Then Set mcolSoldCoupons = New Collection
    
    Set oCoupon = m_oSession.Database.CreateBusinessObject(CLASSID_SOLDCOUPON)
    Set oCoupon.POSHeader = Me
    oCoupon.StoreID = m_oSession.CurrentEnterprise.IEnterprise_StoreNumber
    oCoupon.TransactionDate = mTranDate
    oCoupon.TransactionTill = mTillID
    oCoupon.TransactionNumber = mTransactionNo
    oCoupon.CouponID = CouponID
    oCoupon.ExclusiveCoupon = ExcCoupon
    oCoupon.MarketRef = MarketRef
    oCoupon.SerialNo = SerialNo
    oCoupon.Status = Status
    oCoupon.RTIFlag = "S"
    
    Call mcolSoldCoupons.Add(oCoupon)
    oCoupon.Sequence = Format(mcolSoldCoupons.Count, "0000")
    Set AddCoupon = oCoupon

End Function

Public Function AddGiftVoucher(Serial As String, Value As Currency, TType As String) As cPOSGiftVoucher

Dim oGV As cPOSGiftVoucher

    Set oGV = m_oSession.Database.CreateBusinessObject(CLASSID_POSGIFTVOUCHERS)
'    Set oGV.POSHeader = Me
    oGV.TranDate = mTranDate
    oGV.TillID = mTillID
    oGV.TransactionNumber = mTransactionNo
    
    If mcolGiftVouchers Is Nothing Then Set mcolGiftVouchers = New Collection
    Call mcolGiftVouchers.Add(oGV)
    oGV.SequenceNo = mcolGiftVouchers.Count
    
    oGV.SerialNo = Serial
    oGV.CashierID = mCashierID
    oGV.TransactionCode = TType
    oGV.VoucherAmount = Value
    oGV.CommedToHO = False
    
    Set AddGiftVoucher = oGV
    
End Function

Public Function AddPaymentComm(ByVal seqNo As Long) As cPOSPaymentComm

Dim oPmtComm As cPOSPaymentComm

    Set oPmtComm = m_oSession.Database.CreateBusinessObject(CLASSID_POSPAYMENTCOMM)
    Set oPmtComm.POSHeader = Me
    oPmtComm.TransactionDate = mTranDate
    oPmtComm.TillID = mTillID
    oPmtComm.TransactionNumber = mTransactionNo
    oPmtComm.SequenceNumber = seqNo
    
    If mcolPaymentComms Is Nothing Then
        Set mcolPaymentComms = New Collection
    End If
    Call mcolPaymentComms.Add(oPmtComm)
    Set AddPaymentComm = oPmtComm
End Function

Public Property Get Payments() As Collection

' Returns the payments (invoice tenders) for the invoice
Dim oPayment    As cSale_Wickes.cPOSPayment
Dim oRSelector  As IRowSelector
Dim oBoSortKeys As IBoSortKeys
    
    If mcolPayments Is Nothing Then
        Call DebugMsg(MODULE_NAME, "Payments", endlDebug, "Tran " & mTransactionNo & "/" & mTranDate & "/" & mTillID)
        'Get lines for Invoice with the current transaction number.
        Debug.Assert LenB(mTransactionNo) <> 0
        Set oRSelector = m_oSession.Database.CreateBoSelector(CLASSID_POSPAYMENT)
        Call oRSelector.Override(m_oSession.Database.CreateBoSelector(FID_POSPAYMENT_TransactionNumber, _
                    CMP_EQUAL, mTransactionNo))
        Call oRSelector.Override(m_oSession.Database.CreateBoSelector(FID_POSPAYMENT_TransactionDate, _
                    CMP_EQUAL, mTranDate))
        Call oRSelector.Override(m_oSession.Database.CreateBoSelector(FID_POSPAYMENT_TillID, _
                    CMP_EQUAL, mTillID))
        
        ' Order by sequence number within invoice
        Set oBoSortKeys = New CBoSortKeys
        oBoSortKeys.Add FID_POSPAYMENT_SequenceNumber
        
        Set mcolPayments = m_oSession.Database.GetSortedBoCollection(oRSelector, oBoSortKeys)
        Call DebugMsg(MODULE_NAME, "Payments", endlDebug, "Tran " & mTransactionNo & ",No Lines=" & mcolPayments.Count)
        Debug.Assert Not (mcolPayments Is Nothing)
        'Point line to reference Return Note Header
        For Each oPayment In mcolPayments
            Set oPayment.POSHeader = Me
        Next oPayment
    End If
    
    Set Payments = mcolPayments
    
End Property
Public Property Get Lines(Optional bIsReload As Boolean) As Collection
    
' Returns the lines (invoice items) for the invoice
Dim oLine       As cSale_Wickes.cPOSLine
Dim oRSelector  As IRowSelector
Dim oBoSortKeys As IBoSortKeys
    
    If (mcolLines Is Nothing) Or bIsReload Then
        Call DebugMsg(MODULE_NAME, "Lines", endlDebug, "Tran " & mTransactionNo & "/" & mTranDate & "/" & mTillID)
        'Get lines for Invoice with the current transaction number.
        Debug.Assert LenB(mTransactionNo) <> 0
        
        Dim giftCardSku As String
        giftCardSku = m_oSession.GetParameter(979)
        
        Set oRSelector = m_oSession.Database.CreateBoSelector(CLASSID_POSLINE)
        Call oRSelector.Override(m_oSession.Database.CreateBoSelector(FID_POSLINE_TransactionNumber, _
                    CMP_EQUAL, mTransactionNo))
        Call oRSelector.Override(m_oSession.Database.CreateBoSelector(FID_POSLINE_TranDate, _
                    CMP_EQUAL, mTranDate))
        Call oRSelector.Override(m_oSession.Database.CreateBoSelector(FID_POSLINE_TillID, _
                    CMP_EQUAL, mTillID))
        Call oRSelector.Override(m_oSession.Database.CreateBoSelector(FID_POSLINE_PartCode, _
                    CMP_NOTEQUAL, giftCardSku))
        
        ' Order by sequence number within invoice
        Set oBoSortKeys = New CBoSortKeys
        oBoSortKeys.Add FID_POSLINE_SequenceNo
        
        Set mcolLines = m_oSession.Database.GetSortedBoCollection(oRSelector, oBoSortKeys)
        Call DebugMsg(MODULE_NAME, "Lines", endlDebug, "Tran " & mTransactionNo & ",No Lines=" & mcolLines.Count)
        Debug.Assert Not (mcolLines Is Nothing)
        'Point line to reference Return Note Header
        For Each oLine In mcolLines
            Set oLine.POSHeader = Me
        Next oLine
    End If
    Call DebugMsg(MODULE_NAME, "Lines", endlDebug, "Passed Out-Tran " & mTransactionNo & ",No Lines=" & mcolLines.Count)
    
    Set Lines = mcolLines

End Property

Public Property Get Coupons() As Collection

' Returns the Coupons used on the transaction
Dim oSoldCoupon As cSale_Wickes.cSoldCoupon
Dim oRSelector  As IRowSelector
Dim oBoSortKeys As IBoSortKeys
    
    If mcolSoldCoupons Is Nothing Then
        Call DebugMsg(MODULE_NAME, "Coupons", endlDebug, "Tran " & mTransactionNo & "/" & mTranDate & "/" & mTillID)
        'Get lines for Invoice with the current transaction number.
        Debug.Assert LenB(mTransactionNo) <> 0
        Set oRSelector = m_oSession.Database.CreateBoSelector(CLASSID_SOLDCOUPON)
        Call oRSelector.Override(m_oSession.Database.CreateBoSelector(FID_SOLDCOUPON_TransactionNumber, _
                    CMP_EQUAL, mTransactionNo))
        Call oRSelector.Override(m_oSession.Database.CreateBoSelector(FID_SOLDCOUPON_TransactionDate, _
                    CMP_EQUAL, mTranDate))
        Call oRSelector.Override(m_oSession.Database.CreateBoSelector(FID_SOLDCOUPON_TransactionTill, _
                    CMP_EQUAL, mTillID))
        
        ' Order by sequence number within invoice
        Set oBoSortKeys = New CBoSortKeys
        oBoSortKeys.Add FID_SOLDCOUPON_Sequence
        
        Set mcolSoldCoupons = m_oSession.Database.GetSortedBoCollection(oRSelector, oBoSortKeys)
        Call DebugMsg(MODULE_NAME, "Coupons", endlDebug, "Tran " & mTransactionNo & ",No Lines=" & mcolSoldCoupons.Count)
        Debug.Assert Not (mcolSoldCoupons Is Nothing)
        'Point line to reference Return Note Header
        For Each oSoldCoupon In mcolSoldCoupons
            Set oSoldCoupon.POSHeader = Me
        Next oSoldCoupon
    End If
    
    Set Coupons = mcolSoldCoupons
    
End Property

Public Property Get PaymentComms() As Collection
    ' Returns the paymentcomms
    Dim oPaymentComm    As cSale_Wickes.cPOSPaymentComm
    Dim oRSelector  As IRowSelector
    Dim oBoSortKeys As IBoSortKeys
    
    If mcolPaymentComms Is Nothing Then
        Call DebugMsg(MODULE_NAME, "PaymentComms", endlDebug, "Tran " & mTransactionNo & "/" & mTranDate & "/" & mTillID)
        'Get lines with the current transaction number.
        Debug.Assert LenB(mTransactionNo) <> 0
        Set oRSelector = m_oSession.Database.CreateBoSelector(CLASSID_POSPAYMENTCOMM)
        Call oRSelector.Override(m_oSession.Database.CreateBoSelector(FID_POSPAYMENTCOMM_TransactionNumber, _
                    CMP_EQUAL, mTransactionNo))
        Call oRSelector.Override(m_oSession.Database.CreateBoSelector(FID_POSPAYMENTCOMM_TransactionDate, _
                    CMP_EQUAL, mTranDate))
        Call oRSelector.Override(m_oSession.Database.CreateBoSelector(FID_POSPAYMENTCOMM_TillID, _
                    CMP_EQUAL, mTillID))
        ' Order by sequence number
        Set oBoSortKeys = New CBoSortKeys
        oBoSortKeys.Add FID_POSPAYMENTCOMM_SequenceNumber
        
        Set mcolPaymentComms = m_oSession.Database.GetSortedBoCollection(oRSelector, oBoSortKeys)
        Call DebugMsg(MODULE_NAME, "PaymentComms", endlDebug, "Tran " & mTransactionNo & ",No Lines=" & mcolPaymentComms.Count)
        Debug.Assert Not (mcolPaymentComms Is Nothing)
        'Point line to reference Return Note Header
        For Each oPaymentComm In mcolPaymentComms
            Set oPaymentComm.POSHeader = Me
        Next oPaymentComm
    End If
    Set PaymentComms = mcolPaymentComms
End Property

'##ModelId=3D3D1B350032
Public Sub DeleteItem()
End Sub

'##ModelId=3D3D1B390226
Public Sub Process()
End Sub

'##ModelId=3D53CDE40320
Public Property Get TransactionComplete() As Boolean
   Let TransactionComplete = mTransactionComplete
End Property

'##ModelId=3D53CDE302EE
Public Property Let TransactionComplete(ByVal Value As Boolean)
    Let mTransactionComplete = Value
End Property

Public Property Get CustomerAcctNo() As String
   Let CustomerAcctNo = mCustomerAcctNo
End Property

Public Property Let CustomerAcctNo(ByVal Value As String)
    Let mCustomerAcctNo = Value
End Property

Public Property Get CustomerAcctCardNo() As String
   Let CustomerAcctCardNo = mCustomerAcctCardNo
End Property

Public Property Let CustomerAcctCardNo(ByVal Value As String)
    Let mCustomerAcctCardNo = Value
End Property

'##ModelId=3D53CDDE005A
Public Property Get AccountSale() As Boolean
   Let AccountSale = mAccountSale
End Property

'##ModelId=3D53CDDD006E
Public Property Let AccountSale(ByVal Value As Boolean)
    Let mAccountSale = Value
End Property

'##ModelId=3D53CDD7030C
Public Property Get VATValue(Index As Variant) As Double
   Let VATValue = mVATValue(Index)
End Property

'##ModelId=3D53CDD60348
Public Property Let VATValue(Index As Variant, ByVal Value As Double)
    Let mVATValue(Index) = Value
End Property

'##ModelId=3D53CDD6012C
Public Property Get ExVATValue(Index As Variant) As Double
   Let ExVATValue = mExVATValue(Index)
End Property

'##ModelId=3D53CDD50168
Public Property Let ExVATValue(Index As Variant, ByVal Value As Double)
    Let mExVATValue(Index) = Value
End Property

'##ModelId=3D53CDD4032A
Public Property Get VATSymbol(Index As Variant) As String
   Let VATSymbol = mVATSymbol(Index)
End Property

'##ModelId=3D53CDD303A2
Public Property Let VATSymbol(Index As Variant, ByVal Value As String)
    Let mVATSymbol(Index) = Value
End Property

'##ModelId=3D53CDD3014A
Public Property Get VATRates(Index As Variant) As Double
   Let VATRates = mVATRates(Index)
End Property

'##ModelId=3D53CDD201C2
Public Property Let VATRates(Index As Variant, ByVal Value As Double)
    Let mVATRates(Index) = Value
End Property

'##ModelId=3D53CDD10384
Public Property Get TotalSaleAmount() As Double
   Let TotalSaleAmount = mTotalSaleAmount
End Property

'##ModelId=3D53CDD10050
Public Property Let TotalSaleAmount(ByVal Value As Double)
    Let mTotalSaleAmount = Value
End Property

'##ModelId=3D53CDD00212
Public Property Get DiscountAmount() As Double
   Let DiscountAmount = mDiscountAmount
End Property

'##ModelId=3D53CDCF028A
Public Property Let DiscountAmount(ByVal Value As Double)
    Let mDiscountAmount = Value
End Property

'##ModelId=3D53CDCF0096
Public Property Get TaxAmount() As Double
   Let TaxAmount = mTaxAmount
End Property

'##ModelId=3D53CDCE0118
Public Property Let TaxAmount(ByVal Value As Double)
    Let mTaxAmount = Value
End Property

'##ModelId=3D53CDCD030C
Public Property Get NonMerchandiseAmount() As Double
   Let NonMerchandiseAmount = mNonMerchandiseAmount
End Property

'##ModelId=3D53CDCC03C0
Public Property Let NonMerchandiseAmount(ByVal Value As Double)
    Let mNonMerchandiseAmount = Value
End Property

'##ModelId=3D53CDCC01CC
Public Property Get MerchandiseAmount() As Double
   Let MerchandiseAmount = mMerchandiseAmount
End Property

'##ModelId=3D53CDCB0280
Public Property Let MerchandiseAmount(ByVal Value As Double)
    Let mMerchandiseAmount = Value
End Property

'##ModelId=3D53CDCB0096
Public Property Get DiscountSupervisor() As String
   Let DiscountSupervisor = mDiscountSupervisor
End Property

'##ModelId=3D53CDCA017C
Public Property Let DiscountSupervisor(ByVal Value As String)
    Let mDiscountSupervisor = Value
End Property

'##ModelId=3D53CDC90370
Public Property Get VoidSupervisor() As String
   Let VoidSupervisor = mVoidSupervisor
End Property

'##ModelId=3D53CDC9006E
Public Property Let VoidSupervisor(ByVal Value As String)
    Let mVoidSupervisor = Value
End Property

Public Property Get SaveStatus() As String
   Let SaveStatus = mSaveStatus
End Property

Public Property Let SaveStatus(ByVal Value As String)
    Let mSaveStatus = Value
End Property

Public Property Get SaveSequenceNo() As String
   Let SaveSequenceNo = mSaveSequenceNo
End Property

Public Property Let SaveSequenceNo(ByVal Value As String)
    Let mSaveSequenceNo = Value
End Property

'##ModelId=3D53CDC8026C
Public Property Get SupervisorUsed() As Boolean
   Let SupervisorUsed = mSupervisorUsed
End Property

'##ModelId=3D53CDC70384
Public Property Let SupervisorUsed(ByVal Value As Boolean)
    Let mSupervisorUsed = Value
End Property

'##ModelId=3D53CDC7019A
Public Property Get SupervisorNo() As String
   Let SupervisorNo = mSupervisorNo
End Property

'##ModelId=3D53CDC602BC
Public Property Let SupervisorNo(ByVal Value As String)
    Let mSupervisorNo = Value
End Property

'##ModelId=3D53CDC60104
Public Property Get TranParked() As Boolean
   Let TranParked = mTranParked
End Property

'##ModelId=3D53CDC501EA
Public Property Let TranParked(ByVal Value As Boolean)
    Let mTranParked = Value
End Property

'##ModelId=3D53CDC3037A
Public Property Get DailyUpdateProc() As Boolean
   Let DailyUpdateProc = mDailyUpdateProc
End Property

'##ModelId=3D53CDC300B4
Public Property Let DailyUpdateProc(ByVal Value As Boolean)
    Let mDailyUpdateProc = Value
End Property

'##ModelId=3D53CDC202E4
Public Property Get TrainingMode() As Boolean
   Let TrainingMode = mTrainingMode
End Property

'##ModelId=3D53CDC20050
Public Property Let TrainingMode(ByVal Value As Boolean)
    Let mTrainingMode = Value
End Property

'##ModelId=3D53CDC102BC
Public Property Get Voided() As Boolean
   Let Voided = mVoided
End Property

'##ModelId=3D53CDC1005A
Public Property Let Voided(ByVal Value As Boolean)
    Let mVoided = Value
End Property

'##ModelId=3D53CDC002C6
Public Property Get OrderNumber() As String
   Let OrderNumber = mOrderNumber
End Property

'##ModelId=3D53CDC0006E
Public Property Let OrderNumber(ByVal Value As String)
    Let mOrderNumber = Value
End Property

'##ModelId=3D53CDBF02D0
Public Property Get ReasonCode() As Long
   Let ReasonCode = mReasonCode
End Property

'##ModelId=3D53CDBF00AA
Public Property Let ReasonCode(ByVal Value As Long)
    Let mReasonCode = Value
End Property

'##ModelId=3D53CDBE0316
Public Property Get OpenDrawerCode() As Long
   Let OpenDrawerCode = mOpenDrawerCode
End Property

'##ModelId=3D53CDBE00F0
Public Property Let OpenDrawerCode(ByVal Value As Long)
    Let mOpenDrawerCode = Value
End Property

'##ModelId=3D53CDBD038E
Public Property Get TransactionCode() As String
   Let TransactionCode = mTransactionCode
End Property

'##ModelId=3D53CDBD012C
Public Property Let TransactionCode(ByVal Value As String)
    Let mTransactionCode = Value
End Property

'##ModelId=3D53CDBB014A
Public Property Get TransactionTime() As String
   Let TransactionTime = Format$(mTransactionTime, "HHNNSS")
End Property

'##ModelId=3D53CDBA030C
Public Property Let TransactionTime(ByVal Value As String)
    Let mTransactionTime = "01/01/1901 " & Format$(Value, "00:00:00")
End Property

Public Property Get TransactionDateTime() As Date
   ' Derived property for convenience.
   Let TransactionDateTime = CDate(Format$(mTranDate, "DD/MM/YYYY ") & Format$(mTransactionTime, "HH:NN:SS"))
End Property

'##ModelId=3D53CDBA01F4
Public Property Get CashierID() As String
   Let CashierID = mCashierID
End Property

'##ModelId=3D53CDBA000A
Public Property Let CashierID(ByVal Value As String)
    Let mCashierID = Value
End Property

'##ModelId=3D53CDB902DA
Public Property Get TransactionNo() As String
   Let TransactionNo = mTransactionNo
End Property

'##ModelId=3D53CDB900F0
Public Property Let TransactionNo(ByVal Value As String)
    Let mTransactionNo = Value
    If ((moCustomer Is Nothing) = False) Then moCustomer.TransactionNumber = mTransactionNo
End Property

'##ModelId=3D53CDB803C0
Public Property Get TillID() As String
   Let TillID = mTillID
End Property

'##ModelId=3D53CDB80212
Public Property Let TillID(ByVal Value As String)
    Let mTillID = Value
    If ((moCustomer Is Nothing) = False) Then moCustomer.PCTillID = mTillID
End Property

'##ModelId=3D53CDB800FA
Public Property Get TranDate() As Date
   Let TranDate = mTranDate
End Property

'##ModelId=3D53CDB7032A
Public Property Let TranDate(ByVal Value As Date)
    Let mTranDate = Value
    If ((moCustomer Is Nothing) = False) Then moCustomer.TransactionDate = mTranDate
End Property

Public Property Let CollectPostCode(ByVal Value As Boolean)
    mCollectPostCode = Value
End Property

Public Property Get CollectPostCode() As Boolean
    CollectPostCode = mCollectPostCode
End Property

Public Property Let FromDCOrders(ByVal Value As Boolean)
    mFromDCOrders = Value
End Property

Public Property Let EmployeeDiscountOnly(ByVal Value As Boolean)
    mEmployeeDiscountOnly = Value
End Property

Public Property Get EmployeeDiscountOnly() As Boolean
    EmployeeDiscountOnly = mEmployeeDiscountOnly
End Property

Public Property Let RefundCashier(ByVal Value As String)
    mRefundCashier = Value
End Property

Public Property Get RefundCashier() As String
    RefundCashier = mRefundCashier
End Property

Public Property Let RefundSupervisor(ByVal Value As String)
    mRefundSupervisor = Value
End Property

Public Property Get RefundSupervisor() As String
    RefundSupervisor = mRefundSupervisor
End Property

Public Property Let RefundManager(ByVal Value As String)
    mRefundManager = Value
End Property

Public Property Get RefundManager() As String
    RefundManager = mRefundManager
End Property

Public Property Let TenderOverrideCode(ByVal Value As String)
    mTenderOverrideCode = Value
End Property

Public Property Get TenderOverrideCode() As String
    TenderOverrideCode = mTenderOverrideCode
End Property

Public Property Let RecoveredFromParked(ByVal Value As Boolean)
    mRecoveredFromParked = Value
End Property

Public Property Get RecoveredFromParked() As Boolean
    RecoveredFromParked = mRecoveredFromParked
End Property

Public Property Let Offline(ByVal Value As Boolean)
    mOffline = Not Value
End Property

Public Property Get Offline() As Boolean
    Offline = Not mOffline
End Property

Public Property Let GiftTokensPrinted(ByVal Value As Long)
    mGiftTokensPrinted = Value
End Property

Public Property Get GiftTokensPrinted() As Long
    GiftTokensPrinted = mGiftTokensPrinted
End Property

Public Property Let Description(ByVal Value As String)
    mDescription = Value
End Property

Public Property Get Description() As String
    Description = mDescription
End Property

Public Property Let ExternalDocumentNo(ByVal Value As String)
    mExternalDocumentNo = Value
End Property

Public Property Get ExternalDocumentNo() As String
    ExternalDocumentNo = mExternalDocumentNo
End Property

Public Property Let StoreNumber(ByVal Value As String)
    mStoreNumber = Value
End Property

Public Property Get StoreNumber() As String
    StoreNumber = mStoreNumber
End Property

Public Property Let ColleagueCardNo(ByVal Value As String)
    mColleagueCardNo = Value
End Property

Public Property Get ColleagueCardNo() As String
    ColleagueCardNo = mColleagueCardNo
End Property

Public Property Get OnlineUpdate() As Boolean
   Let OnlineUpdate = mblnOnlineUpdate
End Property

Public Property Let OnlineUpdate(ByVal Value As Boolean)
    Let mblnOnlineUpdate = Value
End Property

Public Property Let DiscountCardNumber(ByVal Value As String)
    mDiscountCardNumber = Value
End Property

Public Property Get DiscountCardNumber() As String
    DiscountCardNumber = mDiscountCardNumber
End Property

Public Property Get PromptRejects() As Collection
   Set PromptRejects = mcolPromptRejects
End Property

Public Property Set PromptRejects(ByVal Value As Collection)
    Set mcolPromptRejects = Value
End Property

Public Property Let Source(ByVal Value As String)
    mSource = Value
End Property

Public Property Get Source() As String
    Source = mSource
End Property

Public Property Let ReceiptBarcode(ByVal Value As String)
    mReceiptBarcode = Value
End Property

Public Property Get ReceiptBarcode() As String
    ReceiptBarcode = mReceiptBarcode
End Property

'<CACH>****************************************************************************************
'* Function:  Boolean LoadFromRow()
'**********************************************************************************************
'* Description: Part of the IBo interface called by the DB object to pass in a row of field and
'*              for this object to extract the data and populate the properties of the object.
'**********************************************************************************************
'* Parameters:
'*In/Out:oRow   Object. - collection of fields
'**********************************************************************************************
'* Returns:  Boolean
'**********************************************************************************************
'* History:
'* 08/08/02    mauricem
'*             Header added.
'</CACH>***************************************************************************************
Public Function LoadFromRow(oRow As IRow) As Boolean

Dim lFieldNo As Integer
Dim oField   As IField

Const PROCEDURE_NAME As String = MODULE_NAME & ".LoadFromRow"

    LoadFromRow = True
    For lFieldNo = 1 To oRow.Count Step 1
        Set oField = oRow.Field(lFieldNo)
        If Not m_dicFidsLoaded.Exists(oField.Id) Then m_dicFidsLoaded.Add oField.Id, oField.Id
        Select Case (oField.Id)
            Case (FID_POSHEADER_TranDate):              mTranDate = oField.ValueAsVariant
            Case (FID_POSHEADER_TillID):                mTillID = oField.ValueAsVariant
            Case (FID_POSHEADER_TransactionNo):         mTransactionNo = oField.ValueAsVariant
            Case (FID_POSHEADER_CashierID):             mCashierID = oField.ValueAsVariant
            Case (FID_POSHEADER_TransactionTime):       TransactionTime = oField.ValueAsVariant
            Case (FID_POSHEADER_TransactionCode):       mTransactionCode = oField.ValueAsVariant
            Case (FID_POSHEADER_OpenDrawerCode):        mOpenDrawerCode = oField.ValueAsVariant
            Case (FID_POSHEADER_ReasonCode):            mReasonCode = oField.ValueAsVariant
            Case (FID_POSHEADER_OrderNumber):           mOrderNumber = oField.ValueAsVariant
            Case (FID_POSHEADER_Voided):                mVoided = oField.ValueAsVariant
            Case (FID_POSHEADER_TrainingMode):          mTrainingMode = oField.ValueAsVariant
            Case (FID_POSHEADER_DailyUpdateProc):       mDailyUpdateProc = oField.ValueAsVariant
            Case (FID_POSHEADER_TranParked):            mTranParked = oField.ValueAsVariant
            Case (FID_POSHEADER_SupervisorNo):          mSupervisorNo = oField.ValueAsVariant
            Case (FID_POSHEADER_SupervisorUsed):        mSupervisorUsed = oField.ValueAsVariant
            Case (FID_POSHEADER_VoidSupervisor):        mVoidSupervisor = oField.ValueAsVariant
            Case (FID_POSHEADER_DiscountSupervisor):    mDiscountSupervisor = oField.ValueAsVariant
            Case (FID_POSHEADER_MerchandiseAmount):     mMerchandiseAmount = oField.ValueAsVariant
            Case (FID_POSHEADER_NonMerchandiseAmount):  mNonMerchandiseAmount = oField.ValueAsVariant
            Case (FID_POSHEADER_TaxAmount):             mTaxAmount = oField.ValueAsVariant
            Case (FID_POSHEADER_DiscountAmount):        mDiscountAmount = oField.ValueAsVariant
            Case (FID_POSHEADER_TotalSaleAmount):       mTotalSaleAmount = oField.ValueAsVariant
            Case (FID_POSHEADER_VATRates):              Call LoadDoubleArray(mVATRates, oField, m_oSession)
            Case (FID_POSHEADER_VATSymbol):             Call LoadStringArray(mVATSymbol, oField, m_oSession)
            Case (FID_POSHEADER_ExVATValue):            Call LoadDoubleArray(mExVATValue, oField, m_oSession)
            Case (FID_POSHEADER_VATValue):              Call LoadDoubleArray(mVATValue, oField, m_oSession)
            Case (FID_POSHEADER_TransactionComplete):   mTransactionComplete = oField.ValueAsVariant
            Case (FID_POSHEADER_CustomerAcctNo):        mCustomerAcctNo = oField.ValueAsVariant
            Case (FID_POSHEADER_CustomerAcctCardNo):    mCustomerAcctCardNo = oField.ValueAsVariant
            Case (FID_POSHEADER_CollectPostCode):       mCollectPostCode = oField.ValueAsVariant
            Case (FID_POSHEADER_FromDCOrders):          mFromDCOrders = oField.ValueAsVariant
            Case (FID_POSHEADER_EmployeeDiscountOnly):  mEmployeeDiscountOnly = oField.ValueAsVariant
            Case (FID_POSHEADER_RefundCashier):         mRefundCashier = oField.ValueAsVariant
            Case (FID_POSHEADER_RefundSupervisor):      mRefundSupervisor = oField.ValueAsVariant
            Case (FID_POSHEADER_RefundManager):         mRefundManager = oField.ValueAsVariant
            Case (FID_POSHEADER_TenderOverrideCode):    mTenderOverrideCode = oField.ValueAsVariant
            Case (FID_POSHEADER_RecoveredFromParked):   mRecoveredFromParked = oField.ValueAsVariant
            Case (FID_POSHEADER_Offline):               mOffline = oField.ValueAsVariant
            Case (FID_POSHEADER_GiftTokensPrinted):     mGiftTokensPrinted = oField.ValueAsVariant
            Case (FID_POSHEADER_Description):           mDescription = oField.ValueAsVariant
            Case (FID_POSHEADER_AccountSale):           mAccountSale = oField.ValueAsVariant
            Case (FID_POSHEADER_ExternalDocumentNo):    mExternalDocumentNo = oField.ValueAsVariant
            Case (FID_POSHEADER_StoreNumber):           mStoreNumber = oField.ValueAsVariant
            Case (FID_POSHEADER_ColleagueCardNo):       mColleagueCardNo = oField.ValueAsVariant
            Case (FID_POSHEADER_SaveStatus):            mSaveStatus = oField.ValueAsVariant
            Case (FID_POSHEADER_SaveSequenceNo):        mSaveSequenceNo = oField.ValueAsVariant
            Case (FID_POSHEADER_DiscountCardNo):        mDiscountCardNumber = oField.ValueAsVariant
            Case (FID_POSHEADER_Source):        mSource = oField.ValueAsVariant
            Case (FID_POSHEADER_ReceiptBarcode):        mReceiptBarcode = oField.ValueAsVariant
            
Case Else: 'invalid field ID passed in
                LoadFromRow = False
        End Select
    Next lFieldNo

End Function 'LoadFromRow

Private Sub Class_Initialize()
    Set m_dicFidsLoaded = New Dictionary
End Sub

Public Property Get IBo_ClassId() As Integer

    IBo_ClassId = CLASSID_POSHEADER

End Property

Public Property Get IBo_ClassName() As String

    IBo_ClassName = MODULE_NAME

End Property

Private Property Get IBo_DebugString() As String
    
    IBo_DebugString = "POSHeader " & mTransactionNo

End Property

Private Function IBo_Initialise(oSession As ISession) As IBo
    
    Set m_oSession = oSession
    Set IBo_Initialise = Me

End Function

Private Function ISysBo_LoadFromRow(oRow As IRow) As Boolean

    Call LoadFromRow(oRow)

End Function

Private Property Get IBo_Version() As String
    
    IBo_Version = App.Major & "." & App.Minor & "." & Format(App.Revision, "000")

End Property

Private Function Load(Optional RowSelector As IRowSelector = Nothing) As Boolean
    
' Load up all properties from the database
Dim oView       As IView
    
    Load = False
    mSaveFailedStatus = ""
    Call CheckIsUnInitialised(m_oSession, IBo_ClassName)
    
    If Not RowSelector Is Nothing Then
        ' User supplied selector
        RowSelector.AddSelection CMP_EQUAL, GetField(FID_POSHEADER_TranDate), True
        RowSelector.AddSelection CMP_EQUAL, GetField(FID_POSHEADER_TillID), True
        RowSelector.AddSelection CMP_EQUAL, GetField(FID_POSHEADER_TransactionNo), True
        ' Pass the selector to the database to get the data view
        Set oView = m_oSession.Database.GetView(RowSelector)
    Else
        If moRowSel Is Nothing Then Set moRowSel = New CRowSelector
        Call moRowSel.Merge(GetSelectAllRow)
    
        ' Pass the selector to the database to get the data view
        Set oView = m_oSession.Database.GetView(moRowSel)
    End If
    
    If Not (oView Is Nothing) Then
        If oView.Count > 0 Then Load = LoadFromRow(oView.Row(1))
    End If

End Function

Public Function IBo_Save() As Boolean

    IBo_Save = Save(SaveTypeAllCases)

End Function

Public Function IBo_SaveIfNew() As Boolean
    IBo_SaveIfNew = SaveIfNew
End Function

Public Function SaveIfNew() As Boolean

    SaveIfNew = Save(SaveTypeIfNew)

End Function

Public Function IBo_SaveIfExists() As Boolean
    IBo_SaveIfExists = SaveIfExists
End Function

Public Function SaveIfExists() As Boolean

    SaveIfExists = Save(SaveTypeIfExists)

End Function

Public Function IBo_Delete() As Boolean
    IBo_Delete = False
End Function

Public Function Delete() As Boolean

    Delete = Save(SaveTypeDelete)

End Function

Public Function IBo_IsValid() As Boolean

    IBo_IsValid = IsValid()

End Function

'##ModelId=3D3D19F30316
Private Function Save(eSave As enSaveType) As Boolean
' Save all properties to the database
Dim lngLineNo   As Long
Dim oPOSLine    As cPOSLine
Dim oPOSPaid    As cPOSPayment
Dim oPOSComm    As cPOSPaymentComm
Dim oEvtLine    As cEventTranLine
Dim oPPLine     As cPriceLineInfo
Dim oEANCheckBO As cEANCheck
Dim fFSObject   As Scripting.FileSystemObject
Dim tTranFile   As TextStream
Static oSysOpt  As cSystemOptions
Dim strFileP    As String

Dim oRetCust  As cReturnCust
Dim colRetCus As Collection

Dim oMissEAN  As cPOSMissingEAN
Dim colMEAN   As Collection

Dim strLineStart As String
Dim oSKURejectBO As cSKUReject

Dim oSoldCoupon  As cSoldCoupon

    Save = False
    mSaveFailedStatus = ""
    
    If IsValid() Then
        If eSave = SaveTypeIfNew Then
            If (mblnOnlineUpdate = False) Then
                Call DebugMsg(MODULE_NAME, "Save", endlDebug, "Updating OnLine Transaction-" & mTransactionNo)
                mTranDate = Date
                mTransactionTime = Format$(Now(), "HH:NN:SS")
                mTransactionNo = NextTransactionNo
            End If
            'mOffline = True
            If LenB(mSupervisorNo) = 0 Then mSupervisorNo = "000"
            If LenB(mOrderNumber) = 0 Then mOrderNumber = "000000"
            If LenB(mVoidSupervisor) = 0 Then mVoidSupervisor = "000"
            If LenB(mExternalDocumentNo) = 0 Then mExternalDocumentNo = "00000000"
            If LenB(mStoreNumber) = 0 Then mStoreNumber = "000"
            If LenB(mDiscountSupervisor) = 0 Then mDiscountSupervisor = "000"
            If LenB(mCustomerAcctNo) = 0 Then mCustomerAcctCardNo = "000000"
            If LenB(mCustomerAcctCardNo) = 0 Then mCustomerAcctCardNo = "00"
            If LenB(mRefundCashier) = 0 Then mRefundCashier = "000"
            If LenB(mRefundSupervisor) = 0 Then mRefundSupervisor = "000"
            If LenB(mRefundManager) = 0 Then mRefundManager = "000"
            If LenB(mTenderOverrideCode) = 0 Then mTenderOverrideCode = "00"
            If LenB(mCustomerAcctNo) = 0 Then mCustomerAcctNo = "000000"
            If LenB(mColleagueCardNo) = 0 Then mColleagueCardNo = "000000000"
            mSaveFailedStatus = "Saving New DLTOTS"
        Else
            mSaveFailedStatus = "Updating DLTOTS"
        End If
        ' Get a row and pass it to the database to insert/update/delete
        If (m_oSession.Database.SaveBo(eSave, Me) = False) Then Exit Function
        
        If mTransactionComplete Then
            If oSysOpt Is Nothing Then
                mSaveFailedStatus = "Loading SYSOPT"
                Set oSysOpt = m_oSession.Database.CreateBusinessObject(CLASSID_SYSTEMOPTIONS)
                oSysOpt.LoadMatches
            End If
            
            If m_oSession.ISession_IsOnline Then
                strFileP = oSysOpt.TillRemoteDrive & ":\" & Trim$(oSysOpt.TillPathName) & "\UPDATED\" & mTillID & mTransactionNo & ".DTU"
            Else
                strFileP = oSysOpt.TillLocalDrive & ":\" & Trim$(oSysOpt.TillPathName) & "\HISTORY\" & mTillID & mTransactionNo & ".DTA"
            End If
            Call UpdateSaveStatus("10", "")
            Set fFSObject = New Scripting.FileSystemObject
            mSaveFailedStatus = "Creating Log File-" & strFileP
            If (mblnOnlineUpdate = False) Then Set tTranFile = fFSObject.OpenTextFile(strFileP, ForWriting, True)
            
            strLineStart = "YNNNNNN "
            
            If (mblnOnlineUpdate = False) Then Call tTranFile.Write("DT" & strLineStart & Trim$(GetFileLine) & vbNewLine)
        End If
        
        'Save each line for the Sales Receipt Note
        If (mcolLines Is Nothing) = False Then
            For lngLineNo = 1 To mcolLines.Count Step 1
                Call UpdateSaveStatus("20", "" & lngLineNo)
                mSaveFailedStatus = "Saving Lines (DB)" & lngLineNo & " of " & mcolLines.Count
                Set oPOSLine = mcolLines(lngLineNo)
                oPOSLine.TransactionNumber = Me.TransactionNo
                If (oPOSLine.SaveIfNew = False) Then Exit Function
                If mTransactionComplete Then
                    mSaveFailedStatus = "Saving Lines (FILE)" & lngLineNo & " of " & mcolLines.Count
                    If (mblnOnlineUpdate = False) Then Call tTranFile.Write("DL" & strLineStart & Trim$(oPOSLine.GetFileLine) & vbNewLine)
                End If
            Next lngLineNo
        End If
        'Save each payment for the Sales Receipt Note
        If (mcolPayments Is Nothing) = False Then
            For lngLineNo = 1 To mcolPayments.Count Step 1
                Call UpdateSaveStatus("30", "" & lngLineNo)
                mSaveFailedStatus = "Saving Payments (DB) " & lngLineNo & " of " & mcolPayments.Count
                Set oPOSPaid = mcolPayments(lngLineNo)
                oPOSPaid.TransactionNumber = Me.TransactionNo
                If (oPOSPaid.SaveIfNew = False) Then Exit Function
                If mTransactionComplete Then
                    mSaveFailedStatus = "Saving Payments (FILE) " & lngLineNo & " of " & mcolPayments.Count
                    If (mblnOnlineUpdate = False) Then Call tTranFile.Write("DP" & strLineStart & Trim$(oPOSPaid.GetFileLine) & vbNewLine)
                End If
                If (oPOSPaid.TenderType = TENTYPE_GIFTCARD) Then
                    oPOSPaid.SaveGiftCard
                End If
            Next lngLineNo
        End If
        'Save each payment comm for the Sales Receipt Note
        If (mcolPaymentComms Is Nothing) = False Then
            For lngLineNo = 1 To mcolPaymentComms.Count Step 1
                Call UpdateSaveStatus("30", "" & lngLineNo)
                mSaveFailedStatus = "Saving PaymentComms (DB) " & lngLineNo & " of " & mcolPaymentComms.Count
                Set oPOSComm = mcolPaymentComms(lngLineNo)
                oPOSComm.TransactionNumber = Me.TransactionNo
                If (oPOSComm.SaveIfNew = False) Then
                    Exit Function
                End If
                If mTransactionComplete Then
                    mSaveFailedStatus = "Saving PaymentComms (FILE) " & lngLineNo & " of " & mcolPaymentComms.Count
                    If (mblnOnlineUpdate = False) Then
                        Call tTranFile.Write("DM" & strLineStart & Trim$(oPOSComm.GetFileLine) & vbNewLine)
                    End If
                End If
            Next lngLineNo
        End If
        'Save each event for the Sales Receipt Note
        If (mcolOPLines Is Nothing) = False Then
            For lngLineNo = 1 To mcolOPLines.Count Step 1
                Call UpdateSaveStatus("40", "" & lngLineNo)
                mSaveFailedStatus = "Saving Events (DB) " & lngLineNo & " of " & mcolOPLines.Count
                Set oEvtLine = mcolOPLines(lngLineNo)
                oEvtLine.TransactionNo = mTransactionNo
                Call oEvtLine.IBo_SaveIfNew
                If mTransactionComplete Then
                    mSaveFailedStatus = "Saving Events(FILE) " & lngLineNo & " of " & mcolOPLines.Count
                    If (mblnOnlineUpdate = False) Then Call tTranFile.Write("DV" & strLineStart & Trim$(oEvtLine.GetFileLine) & vbNewLine)
                End If
            Next lngLineNo
        End If
        If (mblnNewCustomer = True) And (Not moCustomer Is Nothing) Then
            Call UpdateSaveStatus("50", "")
            mSaveFailedStatus = "Saving Customer Record"
            If (moCustomer.SaveIfNew = False) Then Exit Function
        End If
        
        'Save each price promise for the Sales Receipt Note
        If (mcolPricePromise Is Nothing) = False Then
            For lngLineNo = 1 To mcolPricePromise.Count Step 1
                Call UpdateSaveStatus("60", "" & lngLineNo)
                Set oPPLine = mcolPricePromise(lngLineNo)
                mSaveFailedStatus = "Saving Price Promise (DB) " & lngLineNo & " of " & mcolPricePromise.Count
                If (oPPLine.SaveIfNew = False) Then Exit Function
                If mTransactionComplete Then
                    mSaveFailedStatus = "Saving Price Promise Lines (FILE)" & lngLineNo & " of " & mcolPricePromise.Count
                    If (mblnOnlineUpdate = False) Then Call tTranFile.Write("DO" & strLineStart & Trim$(oPPLine.GetFileLine) & vbNewLine)
                End If
            Next lngLineNo
        End If
        
        'WIX1165 - Added 10/3/09 - Save each coupon for the Sales Receipt Note
        If (mcolSoldCoupons Is Nothing) = False Then
            For lngLineNo = 1 To mcolSoldCoupons.Count Step 1
                Call UpdateSaveStatus("65", "" & lngLineNo)
                mSaveFailedStatus = "Saving Coupons (DB) " & lngLineNo & " of " & mcolSoldCoupons.Count
                Set oSoldCoupon = mcolSoldCoupons(lngLineNo)
                oSoldCoupon.TransactionNumber = mTransactionNo
                Call oSoldCoupon.IBo_SaveIfNew
                If mTransactionComplete Then
                    mSaveFailedStatus = "Saving Coupon(FILE) " & lngLineNo & " of " & mcolSoldCoupons.Count
                    If (mblnOnlineUpdate = False) Then Call tTranFile.Write("DN" & strLineStart & Trim$(oSoldCoupon.GetFileLine) & vbNewLine)
                End If
            Next lngLineNo
        End If
        
        If (mblnNewPPCustomer = True) And ((moPPCust Is Nothing) = False) Then
            Call UpdateSaveStatus("70", "")
            mSaveFailedStatus = "Saving Price Promise Customer"
            If (moPPCust.SaveIfNew = False) Then Exit Function
            If mTransactionComplete Then
                mSaveFailedStatus = "Saving Price Promise Cust (FILE)"
                If (mblnOnlineUpdate = False) Then Call tTranFile.Write("DC" & strLineStart & Trim$(moPPCust.GetFileLine) & vbNewLine)
            End If
            mblnNewPPCustomer = False
        End If
        
        If mTransactionComplete Then
            Set colRetCus = ReturnLines
            lngLineNo = 0
            For Each oRetCust In colRetCus
                lngLineNo = lngLineNo + 1
                Call UpdateSaveStatus("80", "" & lngLineNo)
                mSaveFailedStatus = "Saving Return Lines (FILE)"
                If (mblnOnlineUpdate = False) Then Call tTranFile.Write("DR" & strLineStart & Trim$(oRetCust.GetFileLine) & vbNewLine)
            Next

            'Added 9/11/07 - MLM save any SKU Prompt Rejects lines, as they are already saved to DB
            If ((mcolPromptRejects Is Nothing) = False) Then
                For lngLineNo = 1 To mcolPromptRejects.Count Step 1
                    Call UpdateSaveStatus("85", "" & lngLineNo)
                    mSaveFailedStatus = "Saving Offline PromptRejects (DB) " & lngLineNo & " of " & mcolPromptRejects.Count
                    Set oSKURejectBO = mcolPromptRejects(lngLineNo)
                    mSaveFailedStatus = "Saving PromptRejects (FILE) " & lngLineNo & " of " & mcolPromptRejects.Count
                    Call tTranFile.Write("SR" & strLineStart & Trim$(oSKURejectBO.GetFileLine) & vbNewLine)
                Next lngLineNo
            End If
            
            Set colMEAN = MissingEANs
            lngLineNo = 0
            For Each oMissEAN In colMEAN
                lngLineNo = lngLineNo + 1
                Call UpdateSaveStatus("90", "" & lngLineNo)
                mSaveFailedStatus = "Saving Return Lines (FILE)"
                If (mblnOnlineUpdate = False) Then Call tTranFile.Write("DA" & strLineStart & Trim$(oMissEAN.GetFileLine) & vbNewLine)
            Next
            
            Set colRetCus = Nothing
            Set colMEAN = Nothing
            
            'WIX1202-Save each Keyed Entry Audit
            If (mcolEANChecks Is Nothing) = False Then
                For lngLineNo = 1 To mcolEANChecks.Count Step 1
                    Call UpdateSaveStatus("95", "" & lngLineNo)
                    mSaveFailedStatus = "Saving EANChecks (DB) " & lngLineNo & " of " & mcolEANChecks.Count
                    Set oEANCheckBO = mcolEANChecks(lngLineNo)
                    If (oEANCheckBO.SaveIfNew = False) Then Exit Function
                    If mTransactionComplete Then
                        mSaveFailedStatus = "Saving EANChecks (FILE) " & lngLineNo & " of " & mcolEANChecks.Count
                        If (mblnOnlineUpdate = False) Then Call tTranFile.Write("EC" & strLineStart & Trim$(oEANCheckBO.GetFileLine) & vbNewLine)
                    End If
                Next lngLineNo
            End If
            
            'Added 29/10/07 - MLM save any Offline EC lines, as they are already saved to DB
            If (m_oSession.ISession_IsOnline = False) And ((mcolOfflineEANChecks Is Nothing) = False) Then
                For lngLineNo = 1 To mcolOfflineEANChecks.Count Step 1
                    Call UpdateSaveStatus("96", "" & lngLineNo)
                    mSaveFailedStatus = "Saving Offline EANChecks (DB) " & lngLineNo & " of " & mcolOfflineEANChecks.Count
                    Set oEANCheckBO = mcolOfflineEANChecks(lngLineNo)
                    mSaveFailedStatus = "Saving EANChecks (FILE) " & lngLineNo & " of " & mcolOfflineEANChecks.Count
                    Call tTranFile.Write("EC" & strLineStart & Trim$(oEANCheckBO.GetFileLine) & vbNewLine)
                Next lngLineNo
            End If
            
            If (mblnOnlineUpdate = False) Then tTranFile.Close

        End If
        
    End If
    
    Call UpdateSaveStatus("99", "")
    mSaveFailedStatus = ""
    Save = True
    
End Function

Public Sub CreateOfflineFile()

' Save all properties to the database
Dim lngLineNo   As Long
Dim oEANCheckBO As cEANCheck
Dim fFSObject   As Scripting.FileSystemObject
Dim tTranFile   As TextStream
Dim strFileP    As String
Dim oSysOpt     As cSystemOptions

Dim strLineStart As String

    If (m_oSession.ISession_IsOnline = True) Then Exit Sub
        
    Set oSysOpt = m_oSession.Database.CreateBusinessObject(CLASSID_SYSTEMOPTIONS)
    oSysOpt.LoadMatches
        
    strFileP = oSysOpt.TillLocalDrive & ":\" & Trim$(oSysOpt.TillPathName) & "\HISTORY\" & mTillID & Format(Now(), "HHNNSS") & "EC.DTA"
    Set fFSObject = New Scripting.FileSystemObject
    If (mblnOnlineUpdate = False) Then Set tTranFile = fFSObject.OpenTextFile(strFileP, ForWriting, True)
    
    strLineStart = "YNNNNNN "
            
    'Added 29/10/07 - MLM save any Offline EC lines, as they are already saved to DB
    If (mblnOnlineUpdate = False) And ((mcolOfflineEANChecks Is Nothing) = False) Then
        For lngLineNo = 1 To mcolOfflineEANChecks.Count Step 1
            Set oEANCheckBO = mcolOfflineEANChecks(lngLineNo)
            Call tTranFile.Write("EC" & strLineStart & Trim$(oEANCheckBO.GetFileLine) & vbNewLine)
        Next lngLineNo
    End If
    
    Call tTranFile.Close

End Sub

Private Function UpdateSaveStatus(strStatusCode As String, strStatusSequenceNo As String) As Boolean

Dim oRow     As Object 'list of fields to save
Dim blnSaved As Boolean
    
    Set oRow = m_oSession.Root.CreateUtilityObject("CRow")
    ' Identify row by the key
    strStatusSequenceNo = Format(strStatusSequenceNo, "0000")
    Call oRow.Add(GetField(FID_POSHEADER_TranDate))
    Call oRow.Add(GetField(FID_POSHEADER_TillID))
    Call oRow.Add(GetField(FID_POSHEADER_TransactionNo))
    
    'Add the 2 fields that need updating
    mSaveStatus = strStatusCode
    mSaveSequenceNo = strStatusSequenceNo
    Call oRow.Add(GetField(FID_POSHEADER_SaveStatus))
    Call oRow.Add(GetField(FID_POSHEADER_SaveSequenceNo))
        
    blnSaved = m_oSession.Database.SavePartialBo(Me, oRow)
    Debug.Assert blnSaved
    Set oRow = Nothing
    
    UpdateSaveStatus = blnSaved

End Function 'UpdateSaveStatus

Public Function RecordAsVoided() As Boolean

Dim oRow     As Object 'list of fields to save
Dim blnSaved As Boolean
    
    Set oRow = m_oSession.Root.CreateUtilityObject("CRow")
    ' Identify row by the key
    Call oRow.Add(GetField(FID_POSHEADER_TranDate))
    Call oRow.Add(GetField(FID_POSHEADER_TillID))
    Call oRow.Add(GetField(FID_POSHEADER_TransactionNo))
    
    'Add the field that need updating
    mVoided = True
    Call oRow.Add(GetField(FID_POSHEADER_Voided))
        
    blnSaved = m_oSession.Database.SavePartialBo(Me, oRow)
    Debug.Assert blnSaved
    Set oRow = Nothing
    
    RecordAsVoided = blnSaved

End Function 'RecordAsVoided

Public Function SendToHeadOffice() As Boolean

Dim oDTFSend As cEnterprise_Wickes.cDTFMsgSend

    Set oDTFSend = m_oSession.Database.CreateBusinessObject(CLASSID_DTF_SEND)
    Call oDTFSend.CreateMessageToHeadOffice(1, Format(mTranDate, "YYYYMMDD") & "|" & mTillID & "|" & mTransactionNo)
    Set oDTFSend = Nothing
    SendToHeadOffice = True

End Function


Public Property Get EventLines(Optional bIsReload As Boolean) As Collection
    
' Returns the Eventlines (invoice items) for the invoice
Dim oRSelector  As IRowSelector
Dim oBoSortKeys As IBoSortKeys
    
    If (mcolOPLines Is Nothing) Or bIsReload Then
        Call DebugMsg(MODULE_NAME, "Event Lines", endlDebug, "Tran " & mTransactionNo & "/" & mTranDate & "/" & mTillID)
        'Get lines for Invoice with the current transaction number.
        Debug.Assert LenB(mTransactionNo) <> 0
        Set oRSelector = m_oSession.Database.CreateBoSelector(CLASSID_POSEVENTLINE)
        Call oRSelector.Override(m_oSession.Database.CreateBoSelector(FID_POSEVENTLINE_TransactionNo, _
                    CMP_EQUAL, mTransactionNo)) '
        Call oRSelector.Override(m_oSession.Database.CreateBoSelector(FID_POSEVENTLINE_TranDate, _
                    CMP_EQUAL, mTranDate))
        Call oRSelector.Override(m_oSession.Database.CreateBoSelector(FID_POSEVENTLINE_TillID, _
                    CMP_EQUAL, mTillID))
        
        ' Order by sequence number within invoice
        Set oBoSortKeys = New CBoSortKeys
        oBoSortKeys.Add FID_POSLINE_SequenceNo
        
        Set mcolOPLines = m_oSession.Database.GetSortedBoCollection(oRSelector, oBoSortKeys)
        Call DebugMsg(MODULE_NAME, "Lines", endlDebug, "Tran " & mTransactionNo & ",No Lines=" & mcolOPLines.Count)
        Debug.Assert Not (mcolOPLines Is Nothing)
    End If
    Call DebugMsg(MODULE_NAME, "Lines", endlDebug, "Passed Out-Tran " & mTransactionNo & ",No Lines=" & mcolOPLines.Count)
    
    Set EventLines = mcolOPLines

End Property 'Get EventLines

Private Function IsValid() As Boolean
'    Debug.Assert False
    IsValid = True
End Function

Public Function IsSignicantStockTransaction() As Boolean
' A transaction may be for training or be voided or for any other reason not
' significant from a stock movement (stock take) point of view.
' This method allows folks to tell whether to disregard it as insignificant.
    IsSignicantStockTransaction = True
    CheckFidLoaded FID_POSHEADER_Voided
    CheckFidLoaded FID_POSHEADER_TrainingMode
    If Voided Then IsSignicantStockTransaction = False
    If mTrainingMode Then IsSignicantStockTransaction = False
End Function

Public Function SaveFailedStatus() As String
'When saving the entry, this tracks the current stage reached

    SaveFailedStatus = mSaveFailedStatus

End Function

Private Function CheckFidLoaded(nFid As Long) As Boolean

Dim oRSelector As IRowSelector
    
    If m_dicFidsLoaded.Exists(nFid) Then
        CheckFidLoaded = True
    Else
        Debug.Assert False  ' Inefficient loading of properties
        Set oRSelector = New CRowSelector
        oRSelector.AddSelectAll (nFid)
        CheckFidLoaded = Load(oRSelector)
    End If
End Function

Private Function GetAllFieldsAsRow() As IRow
' Returns a CRow object containing one field object for each property.
    
Dim oRow    As IRow
Dim nFid    As Long
    
    Set oRow = New CRow
    For nFid = (CLASSID_POSHEADER * &H10000) + 1 To FID_POSHEADER_END_OF_STATIC Step 1
        oRow.Add GetField(nFid)
    Next nFid
    Set GetAllFieldsAsRow = oRow

End Function

'<CACH>****************************************************************************************
'* Function:  Boolean IBo_AddLoadFilter()
'**********************************************************************************************
'* Description: Part of the IBo Interface.  Used to set-up any selection criteria before
'*              calling the IBo_Load method.  This appends the selection criteria to the
'*              oRowSel object which is used by the IBo_Load method.
'**********************************************************************************************
'* Parameters:
'*In/Out:Comparator Long. - Comparison Type - see modBO.bas
'*In/Out:FieldID    Long. - Unique Field ID against which field to compare against
'*In/Out:Value  Variant. - Value that Field will be compared to
'**********************************************************************************************
'* Returns:  Boolean - True if Valid FieldID and successful
'**********************************************************************************************
'* History:
'* 08/10/02    mauricem
'*             Header added.
'</CACH>***************************************************************************************
Public Function IBo_AddLoadFilter(Comparator As Long, FieldID As Long, Value As Variant) As Boolean
    IBo_AddLoadFilter = AddLoadFilter(Comparator, FieldID, Value)
End Function

Public Function AddLoadFilter(Comparator As Long, FieldID As Long, Value As Variant) As Boolean

Dim oField As IField

Const PROCEDURE_NAME As String = MODULE_NAME & ".AddLoadFilter"

    'Create field for storing Key into
    Set oField = GetField(FieldID)
    If oField Is Nothing Then Exit Function
    oField.ValueAsVariant = Value
    
    'Add field to Row selector
    If moRowSel Is Nothing Then Set moRowSel = New CRowSelector
    Call moRowSel.AddSelection(Comparator, oField)
    AddLoadFilter = True

End Function 'AddLoadFilter

'<CACH>****************************************************************************************
'* Function:  Boolean IBo_AddLoadField()
'**********************************************************************************************
'* Description: Part of the IBo Interface.  Used to set-up all fields that must be returned
'*              when using the LoadMatches method.  This appends the field to the oFieldRow
'*              object which is used by the IBo_LoadMatches method, if it is populated.
'**********************************************************************************************
'* Parameters:
'*In/Out:FieldID    Long. - Unique Field ID against which field to compare against
'**********************************************************************************************
'* History:
'* 09/10/02    mauricem
'*             Header added.
'</CACH>***************************************************************************************
Public Sub IBo_AddLoadField(FieldID As Long)
    AddLoadField FieldID
End Sub
Public Sub AddLoadField(FieldID As Long)

Const PROCEDURE_NAME As String = MODULE_NAME & ".AddLoadField"
    
    'Add field to Row selector
        If moLoadRow Is Nothing Then Set moLoadRow = m_oSession.Root.CreateUtilityObject("CRowSelector")
    Call moLoadRow.AddSelectAll(FieldID)

End Sub      'AddLoadField

Public Sub IBo_ClearLoadFilter()

    Set moRowSel = Nothing

End Sub

Public Sub IBo_ClearLoadField()

    Set moLoadRow = Nothing

End Sub

Public Function IBo_LoadMatches(Optional oReturnRow As IRow = Nothing) As Collection
    Set IBo_LoadMatches = LoadMatches(oReturnRow)
End Function

Public Function LoadMatches(Optional oReturnRow As IRow = Nothing) As Collection

' Load up all properties from the database
Dim oView       As IView
Dim colBO       As Collection
Dim oBO         As ISysBo
Dim lBONo       As Long
Dim oLoadFields As IRowSelector
    
    Set colBO = New Collection
    mSaveFailedStatus = ""
    Call CheckIsUnInitialised(m_oSession, IBo_ClassName)
    
    Set oLoadFields = moRowSel
    If oLoadFields Is Nothing Then Set oLoadFields = New CRowSelector
    
    If oReturnRow Is Nothing Then
        If moLoadRow Is Nothing Then
            Call oLoadFields.Merge(GetSelectAllRow)
        Else
            Call oLoadFields.Merge(moLoadRow) ' add in the specified field
        End If
    Else
        Call oLoadFields.Merge(oReturnRow) ' add in the specified field
    End If
    
    ' Pass the selector to the database to get the data view
    Set oView = m_oSession.Database.GetView(oLoadFields)
    If Not (oView Is Nothing) Then
        For lBONo = 1 To oView.Count Step 1
            Set oBO = m_oSession.Database.CreateBusinessObject(IBo_ClassId)
            Call oBO.LoadFromRow(oView.Row(CLng(lBONo)))
            If lBONo = 1 Then Call LoadFromRow(oView.Row(CLng(lBONo)))
            Call colBO.Add(oBO)
        Next lBONo
    End If
    
    Set LoadMatches = colBO

End Function

Private Function IBo_CreateNew() As IBo
    
    Set IBo_CreateNew = New cPOSHeader

End Function

Public Function IBo_GetField(nFid As Long) As IField
    
    Set IBo_GetField = GetField(nFid)

End Function

Private Function IBo_GetSelectAllRow() As IRowSelector
    
    Set IBo_GetSelectAllRow = GetSelectAllRow

End Function

Public Function IBo_Load() As Boolean

    IBo_Load = Load

End Function

Private Function GetSelectAllRow() As IRowSelector
' Returns a CRow object containing one SelectAll field selector for each property.
    
    Set GetSelectAllRow = GetSelectAllRows(CLASSID_POSHEADER, FID_POSHEADER_END_OF_STATIC, m_oSession)

End Function

Public Function GetField(lFieldID As Long) As IField

    If CheckIsUnInitialised(m_oSession, IBo_ClassName) Then
        lFieldID = 0
        Exit Function
    End If
    On Error GoTo Error_Handler
    
    Select Case (lFieldID)
        Case (FID_POSHEADER_TranDate):
                Set GetField = New CFieldDate
                GetField.ValueAsVariant = mTranDate
        Case (FID_POSHEADER_TillID):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mTillID
        Case (FID_POSHEADER_TransactionNo):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mTransactionNo
        Case (FID_POSHEADER_CashierID):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mCashierID
        Case (FID_POSHEADER_TransactionTime):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = TransactionTime
        Case (FID_POSHEADER_TransactionCode):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mTransactionCode
        Case (FID_POSHEADER_OpenDrawerCode):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mOpenDrawerCode
        Case (FID_POSHEADER_ReasonCode):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mReasonCode
        Case (FID_POSHEADER_OrderNumber):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mOrderNumber
        Case (FID_POSHEADER_Voided):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mVoided
        Case (FID_POSHEADER_TrainingMode):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mTrainingMode
        Case (FID_POSHEADER_DailyUpdateProc):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mDailyUpdateProc
        Case (FID_POSHEADER_TranParked):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mTranParked
        Case (FID_POSHEADER_SupervisorNo):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mSupervisorNo
        Case (FID_POSHEADER_SupervisorUsed):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mSupervisorUsed
        Case (FID_POSHEADER_VoidSupervisor):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mVoidSupervisor
        Case (FID_POSHEADER_DiscountSupervisor):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mDiscountSupervisor
        Case (FID_POSHEADER_MerchandiseAmount):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mMerchandiseAmount
        Case (FID_POSHEADER_NonMerchandiseAmount):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mNonMerchandiseAmount
        Case (FID_POSHEADER_TaxAmount):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mTaxAmount
        Case (FID_POSHEADER_DiscountAmount):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mDiscountAmount
        Case (FID_POSHEADER_TotalSaleAmount):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mTotalSaleAmount
        Case (FID_POSHEADER_VATRates):    Set GetField = SaveDoubleArray(mVATRates, m_oSession)
        Case (FID_POSHEADER_VATSymbol):   Set GetField = SaveStringArray(mVATSymbol, m_oSession)
        Case (FID_POSHEADER_ExVATValue):  Set GetField = SaveDoubleArray(mExVATValue, m_oSession)
        Case (FID_POSHEADER_VATValue):    Set GetField = SaveDoubleArray(mVATValue, m_oSession)
        Case (FID_POSHEADER_AccountSale):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mAccountSale
        Case (FID_POSHEADER_TransactionComplete):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mTransactionComplete
        Case (FID_POSHEADER_CustomerAcctNo):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mCustomerAcctNo
        Case (FID_POSHEADER_CustomerAcctCardNo):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mCustomerAcctCardNo
        Case (FID_POSHEADER_CollectPostCode):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mCollectPostCode
        Case (FID_POSHEADER_FromDCOrders):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mFromDCOrders
        Case (FID_POSHEADER_EmployeeDiscountOnly):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mEmployeeDiscountOnly
        Case (FID_POSHEADER_RefundCashier):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mRefundCashier
        Case (FID_POSHEADER_RefundSupervisor):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mRefundSupervisor
        Case (FID_POSHEADER_RefundManager):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mRefundManager
        Case (FID_POSHEADER_TenderOverrideCode):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mTenderOverrideCode
        Case (FID_POSHEADER_RecoveredFromParked):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mRecoveredFromParked
        Case (FID_POSHEADER_Offline):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mOffline
        Case (FID_POSHEADER_GiftTokensPrinted):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mGiftTokensPrinted
        Case (FID_POSHEADER_Description):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mDescription
        Case (FID_POSHEADER_AccountSale):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mAccountSale
        Case (FID_POSHEADER_ExternalDocumentNo):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mExternalDocumentNo
        Case (FID_POSHEADER_StoreNumber):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mStoreNumber
        Case (FID_POSHEADER_ColleagueCardNo):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mColleagueCardNo
        Case (FID_POSHEADER_SaveStatus):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mSaveStatus
        Case (FID_POSHEADER_SaveSequenceNo):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mSaveSequenceNo
        Case (FID_POSHEADER_DiscountCardNo):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mDiscountCardNumber
        Case (FID_POSHEADER_Source):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mSource
        Case (FID_POSHEADER_ReceiptBarcode):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mReceiptBarcode
        Case Else
                Call Err.Raise(OASYS_ERR_GETFIELD_INVALID_FID, MODULE_NAME, OASYS_ERR_GETFIELD_INVALID_FID_MSG & lFieldID)
    End Select
    
    If Not GetField Is Nothing Then GetField.Id = lFieldID
    
    Exit Function
    
Error_Handler:

    Call MsgBox(MODULE_NAME & " " & "GetField-" & lFieldID & vbCrLf & "Err:" & Err.Number & "-" & Err.Description)
    Resume Next

End Function

Private Function Initialise(oSession As ISession) As cPOSHeader
    Set m_oSession = oSession
    Set Initialise = Me
End Function

Private Function IBo_Interface(Optional eInterfaceType As Long) As IBo

End Function

Public Function IBo_GetAllFieldsAsRow() As IRow
        
    Set IBo_GetAllFieldsAsRow = GetAllFieldsAsRow()

End Function

Public Function IBo_EndOfStaticFieldId() As Long

    IBo_EndOfStaticFieldId = FID_POSHEADER_END_OF_STATIC

End Function

Private Function NextTransactionNo() As String

Const PRM_TRANSNO_PATH As Long = 911

Dim oFSO        As FileSystemObject
Dim tsTranFile  As TextStream
Dim strLine     As String
Dim strFileName As String
Dim lngNextNo   As Long

    Set oFSO = New FileSystemObject
    strFileName = m_oSession.GetParameter(PRM_TRANSNO_PATH)
    strFileName = strFileName & "transno." & m_oSession.CurrentEnterprise.IEnterprise_WorkstationID
    Call DebugMsg(MODULE_NAME, "Next Transaction number", endlDebug, "Looking for file " & strFileName)
    If oFSO.FileExists(strFileName) Then
        Set tsTranFile = oFSO.OpenTextFile(strFileName, ForReading, False)
        strLine = tsTranFile.ReadLine
        Call tsTranFile.Close
                
        If strLine > 5000 Then
            lngNextNo = 1
        Else
            lngNextNo = (Val(strLine) + 1) Mod 5000
            If lngNextNo = 0 Then lngNextNo = 1
        End If
        strLine = Format$(lngNextNo, "0000")
        
        Set tsTranFile = oFSO.OpenTextFile(strFileName, ForWriting, True)
        Call tsTranFile.WriteLine(strLine)
        Call tsTranFile.Close
        NextTransactionNo = strLine
    End If
    Set oFSO = Nothing

End Function

Public Function SaveSignOn(strTillID As String, strUserID As String, Optional strTillVerNo As String = "") As Boolean

Dim intMajor    As Integer
Dim intBuild    As Integer
Dim strVersion  As String

    mTransactionCode = "CO"
    mTillID = strTillID
    mCashierID = strUserID
    mTransactionComplete = True
    If strTillVerNo <> "" Then
        mVATRates(1) = Mid$(strTillVerNo, InStr(strTillVerNo, ".") + 1)
        mVATRates(2) = Mid$(IBo_Version, InStr(IBo_Version, ".") + 1)
    End If
    If m_oSession.ISession_IsOnline Then
        mOffline = True
    Else
        mOffline = False
    End If
    Call SaveIfNew
    SaveSignOn = True

End Function

Public Function SaveSignOff(strTillID As String, strUserID As String) As Boolean

    mTransactionCode = "CC"
    mTillID = strTillID
    mCashierID = strUserID
    mTransactionComplete = True
    If m_oSession.ISession_IsOnline Then
        mOffline = True
    Else
        mOffline = False
    End If
    Call SaveIfNew
    SaveSignOff = True

End Function

Public Function GetPricePromiseLine() As Collection

    Set GetPricePromiseLine = mcolPricePromise
    
End Function

Public Function GetPricePromiseCust() As cPriceCusInfo

    Set GetPricePromiseCust = moPPCust
    
End Function

Public Function ClearPricePromiseCust() As Boolean

    Set moPPCust = Nothing
    
End Function

Public Function LoadPricePromiseInfo() As Boolean

Dim cPriceCustBO    As cPriceCusInfo
Dim cPriceLineBO    As cPriceLineInfo
    
    Set moPPCust = Nothing
    Set mcolPricePromise = Nothing
    
    'Start by getting the Price Customer Info
    Set cPriceCustBO = m_oSession.Database.CreateBusinessObject(CLASSID_PRICECUSINFO)
    Call cPriceCustBO.AddLoadFilter(CMP_EQUAL, FID_PRICECUSINFO_TranDate, mTranDate)
    Call cPriceCustBO.AddLoadFilter(CMP_EQUAL, FID_PRICECUSINFO_TillID, mTillID)
    Call cPriceCustBO.AddLoadFilter(CMP_EQUAL, FID_PRICECUSINFO_TransactionNo, mTransactionNo)
    Call cPriceCustBO.LoadMatches
    
    'Check if Price Customer and if no then exit as there should be no lines
    If (cPriceCustBO.Till <> mTillID) Then Exit Function
    
    'If Price Customer Info then get Price override/match lines
    Set cPriceLineBO = m_oSession.Database.CreateBusinessObject(CLASSID_PRICELINEINFO)
    Call cPriceLineBO.AddLoadFilter(CMP_EQUAL, FID_PRICELINEINFO_TranDate, mTranDate)
    Call cPriceLineBO.AddLoadFilter(CMP_EQUAL, FID_PRICELINEINFO_TillID, mTillID)
    Call cPriceLineBO.AddLoadFilter(CMP_EQUAL, FID_PRICELINEINFO_TransactionNo, mTransactionNo)
    Set mcolPricePromise = cPriceLineBO.LoadMatches
    
    'Pass out values
    Set moPPCust = cPriceCustBO
    LoadPricePromiseInfo = True
    
End Function

Public Function LoadPricePromiseLineInfo() As Boolean

Dim cPriceCustBO    As cPriceCusInfo
Dim cPriceLineBO    As cPriceLineInfo
    
    Set moPPCust = Nothing
    Set mcolPricePromise = Nothing
    
    'Start by getting the Price Customer Info
    Set cPriceCustBO = m_oSession.Database.CreateBusinessObject(CLASSID_PRICECUSINFO)
    Call cPriceCustBO.AddLoadFilter(CMP_EQUAL, FID_PRICECUSINFO_TranDate, mTranDate)
    Call cPriceCustBO.AddLoadFilter(CMP_EQUAL, FID_PRICECUSINFO_TillID, mTillID)
    Call cPriceCustBO.AddLoadFilter(CMP_EQUAL, FID_PRICECUSINFO_TransactionNo, mTransactionNo)
    Call cPriceCustBO.LoadMatches
    
    'If Price Customer Info then get Price override/match lines
    Set cPriceLineBO = m_oSession.Database.CreateBusinessObject(CLASSID_PRICELINEINFO)
    Call cPriceLineBO.AddLoadFilter(CMP_EQUAL, FID_PRICELINEINFO_TranDate, mTranDate)
    Call cPriceLineBO.AddLoadFilter(CMP_EQUAL, FID_PRICELINEINFO_TillID, mTillID)
    Call cPriceLineBO.AddLoadFilter(CMP_EQUAL, FID_PRICELINEINFO_TransactionNo, mTransactionNo)
    Set mcolPricePromise = cPriceLineBO.LoadMatches
    If mcolPricePromise.Count > 0 Then
        LoadPricePromiseLineInfo = True
    End If
    'Pass out values
    Set moPPCust = cPriceCustBO
    
End Function

Public Function GiftVoucherInTran(ByVal strSerial As String) As Boolean

Dim oPOSGiftVoucher As cPOSGiftVoucher

    If Not mcolGiftVouchers Is Nothing Then
        For Each oPOSGiftVoucher In mcolGiftVouchers
            If oPOSGiftVoucher.SerialNo = strSerial Then
                GiftVoucherInTran = True
                Exit Function
            End If
        Next oPOSGiftVoucher
    End If
    
    GiftVoucherInTran = False
    
End Function

Public Sub SaveGiftVouchers()
        
Dim oGVLine      As cPOSGiftVoucher
Dim oRow         As IRow
Static oSysOpt   As cSystemOptions
Dim fFSObject    As Scripting.FileSystemObject
Dim tTranFile    As Scripting.TextStream
Dim strLineStart As String
Dim oGifHot      As cGiftVoucherHotFile
Dim colGifHot    As Collection
Dim strFileP     As String
Dim lngLineNo    As Long
    
    Call UpdateSaveStatus("9a", "")
    If (mblnOnlineUpdate = False) Then
        If oSysOpt Is Nothing Then
            Set oSysOpt = m_oSession.Database.CreateBusinessObject(CLASSID_SYSTEMOPTIONS)
            oSysOpt.LoadMatches
        End If
                
        If m_oSession.ISession_IsOnline Then
            strFileP = oSysOpt.TillRemoteDrive & ":\" & Trim$(oSysOpt.TillPathName) & "\UPDATED\" & mTillID & mTransactionNo & ".DTU"
        Else
            strFileP = oSysOpt.TillLocalDrive & ":\" & Trim$(oSysOpt.TillPathName) & "\HISTORY\" & mTillID & mTransactionNo & ".DTA"
        End If
        Set fFSObject = New Scripting.FileSystemObject
        Set tTranFile = fFSObject.OpenTextFile(strFileP, ForAppending)
    End If
            
    strLineStart = "YNNNNNN "
    
    Call UpdateSaveStatus("9b", "")
    If Not mcolGiftVouchers Is Nothing Then
        Set oGifHot = m_oSession.Database.CreateBusinessObject(CLASSID_GIFTVOUCHERHOTFILE)
        
        lngLineNo = 0
        For Each oGVLine In mcolGiftVouchers
            If (oGVLine.CommedToHO = False) Then
                lngLineNo = lngLineNo + 1
                Call UpdateSaveStatus("9c", "" & lngLineNo)
                Call oGVLine.SaveIfNew
                If (mblnOnlineUpdate = False) Then Call tTranFile.Write("DG" & strLineStart & Trim$(oGVLine.GetFileLine) & vbNewLine)
                
                Call oGifHot.ClearLoadFilter
                Call oGifHot.AddLoadFilter(CMP_EQUAL, FID_GIFTVOUCHERHOTFILE_SerialNumber, oGVLine.SerialNo)
                If (mblnOnlineUpdate = False) Then Set colGifHot = oGifHot.LoadMatches
                
                If Not colGifHot Is Nothing Then
                    If colGifHot.Count <> 0 Then
                        Set oGifHot = colGifHot(1)
                        Call tTranFile.Write("GH" & strLineStart & Trim$(oGifHot.GetFileLine) & vbNewLine)
                    End If
                End If
            End If 'not already saved
        Next
    Else
        If (mblnOnlineUpdate = False) Then tTranFile.Close
        Exit Sub
    End If
    If (mblnOnlineUpdate = False) Then tTranFile.Close

    Call UpdateSaveStatus("9d", "")
    'Added M.Milne - after saving Gift Vouchers - update DLTots with number of vouchers
    Set oRow = m_oSession.Root.CreateUtilityObject("CRow")
    ' Identify row by the key
    Call oRow.Add(GetField(FID_POSHEADER_TranDate))
    Call oRow.Add(GetField(FID_POSHEADER_TillID))
    Call oRow.Add(GetField(FID_POSHEADER_TransactionNo))
    Call oRow.Add(GetField(FID_POSHEADER_GiftTokensPrinted))
    
    Call m_oSession.Database.SavePartialBo(Me, oRow)
        
    Call DebugMsg(MODULE_NAME, "SaveGiftVouchers", endlDebug, "Number Saved - " & mcolGiftVouchers.Count)
    Call UpdateSaveStatus("99", "")

End Sub

Public Sub SaveGiftVoucher(Serial As String, Value As Currency, TType As String)

Dim oGVoucher    As cPOSGiftVoucher
Dim oRow         As IRow
Static oSysOpt   As cSystemOptions
Dim fFSObject    As Scripting.FileSystemObject
Dim tTranFile    As Scripting.TextStream
Dim strLineStart As String
Dim oGifHot      As cGiftVoucherHotFile
Dim colGifHot    As Collection
Dim strFileP     As String
Dim lngLineNo    As Long
    
    Set oGVoucher = AddGiftVoucher(Serial, Value, TType)
    
    Call UpdateSaveStatus("9h", "")
    If (mblnOnlineUpdate = False) Then
        If oSysOpt Is Nothing Then
            Set oSysOpt = m_oSession.Database.CreateBusinessObject(CLASSID_SYSTEMOPTIONS)
            oSysOpt.LoadMatches
        End If
                
        If m_oSession.ISession_IsOnline Then
            strFileP = oSysOpt.TillRemoteDrive & ":\" & Trim$(oSysOpt.TillPathName) & "\UPDATED\" & mTillID & mTransactionNo & ".DTU"
        Else
            strFileP = oSysOpt.TillLocalDrive & ":\" & Trim$(oSysOpt.TillPathName) & "\HISTORY\" & mTillID & mTransactionNo & ".DTA"
        End If
        Set fFSObject = New Scripting.FileSystemObject
        Set tTranFile = fFSObject.OpenTextFile(strFileP, ForAppending)
    End If
            
    strLineStart = "YNNNNNN "
    
    Set oGifHot = m_oSession.Database.CreateBusinessObject(CLASSID_GIFTVOUCHERHOTFILE)
    Call UpdateSaveStatus("9j", "" & Val(oGVoucher.SequenceNo))
            
    Call oGVoucher.SaveIfNew
            
    If (mblnOnlineUpdate = False) Then Call tTranFile.Write("DG" & strLineStart & Trim$(oGVoucher.GetFileLine) & vbNewLine)
            
    oGVoucher.CommedToHO = True 'flagged as saved, so does not get saved twice
    
    Call oGifHot.ClearLoadFilter
    Call oGifHot.AddLoadFilter(CMP_EQUAL, FID_GIFTVOUCHERHOTFILE_SerialNumber, oGVoucher.SerialNo)
    If (mblnOnlineUpdate = False) Then Set colGifHot = oGifHot.LoadMatches
            
    If Not colGifHot Is Nothing Then
        If colGifHot.Count <> 0 Then
            Set oGifHot = colGifHot(1)
            Call tTranFile.Write("GH" & strLineStart & Trim$(oGifHot.GetFileLine) & vbNewLine)
        End If
    End If
    
    If (mblnOnlineUpdate = False) Then tTranFile.Close

    Call UpdateSaveStatus("9k", "")
    
    mGiftTokensPrinted = mcolGiftVouchers.Count
    'Added M.Milne - after saving Gift Vouchers - update DLTots with number of vouchers
    Set oRow = m_oSession.Root.CreateUtilityObject("CRow")
    ' Identify row by the key
    Call oRow.Add(GetField(FID_POSHEADER_TranDate))
    Call oRow.Add(GetField(FID_POSHEADER_TillID))
    Call oRow.Add(GetField(FID_POSHEADER_TransactionNo))
    Call oRow.Add(GetField(FID_POSHEADER_GiftTokensPrinted))
    
    Call m_oSession.Database.SavePartialBo(Me, oRow)
        
    Call DebugMsg(MODULE_NAME, "SaveGiftVouchers", endlDebug, "Number Saved - " & mcolGiftVouchers.Count)
    Call UpdateSaveStatus("99", "")

End Sub

Private Function GetFileLine() As String

Dim strOut As String
Dim lngCounter  As Long
Dim oCashBO     As cCashier
    
    Set oCashBO = m_oSession.Database.CreateBusinessObject(CLASSID_CASHIER)
    Call oCashBO.AddLoadField(FID_CASHIER_Name)
    Call oCashBO.AddLoadField(FID_CASHIER_SignOnCode)
    Call oCashBO.AddLoadFilter(CMP_EQUAL, FID_CASHIER_CashierNumber, mCashierID)
    Set oCashBO = oCashBO.LoadMatches.Item(1)
    
    strOut = ""
    strOut = strOut & FmtVal(mTranDate, enftDate)
    strOut = strOut & FmtVal(mTillID, enftCode, 2)
    strOut = strOut & FmtVal(mTransactionNo, enftCode, 4)
    strOut = strOut & FmtVal(mCashierID, enftCode, 3)
    strOut = strOut & Format$(mTransactionTime, "HHMMSS") ' FmtVal(mTransactionTime, enftCode, 6)
    strOut = strOut & FmtVal(mSupervisorNo, enftCode, 3)
    strOut = strOut & FmtVal(mTransactionCode, enftString, 2)
    strOut = strOut & FmtVal(mOpenDrawerCode, enftCode, 5)
    strOut = strOut & FmtVal(mReasonCode, enftCode, 5)
    strOut = strOut & FmtVal(mDescription, enftString, 20)
    strOut = strOut & FmtVal(mOrderNumber, enftCode, 6)
    strOut = strOut & FmtVal(mAccountSale, enftYesNo)
    strOut = strOut & FmtVal(mVoided, enftYesNo)
    strOut = strOut & FmtVal(mVoidSupervisor, enftCode, 3)
    strOut = strOut & FmtVal(mTrainingMode, enftYesNo)
    strOut = strOut & FmtVal(mDailyUpdateProc, enftYesNo)
    strOut = strOut & FmtVal(mExternalDocumentNo, enftCode, 8)
    strOut = strOut & FmtVal(mSupervisorUsed, enftYesNo)
    strOut = strOut & FmtVal(mStoreNumber, enftCode, 3)
    strOut = strOut & FmtVal(mMerchandiseAmount, enftNumber, 8, 2)
    strOut = strOut & FmtVal(mNonMerchandiseAmount, enftNumber, 8, 2)
    strOut = strOut & FmtVal(mTaxAmount, enftNumber, 8, 2)
    strOut = strOut & FmtVal(mDiscountAmount, enftNumber, 8, 2)
    strOut = strOut & FmtVal(mDiscountSupervisor, enftCode, 3)
    strOut = strOut & FmtVal(mTotalSaleAmount, enftNumber, 8, 2)
    strOut = strOut & FmtVal(mCustomerAcctCardNo, enftCode, 6)
    strOut = strOut & FmtVal(mCustomerAcctNo, enftCode, 2)
    strOut = strOut & FmtVal(mCollectPostCode, enftYesNo)
    strOut = strOut & FmtVal(mFromDCOrders, enftYesNo)
    strOut = strOut & FmtVal(mTransactionComplete, enftYesNo)
    strOut = strOut & FmtVal(mEmployeeDiscountOnly, enftYesNo)
    strOut = strOut & FmtVal(mRefundCashier, enftCode, 3)
    strOut = strOut & FmtVal(mRefundSupervisor, enftCode, 3)
    For lngCounter = 1 To 9 Step 1
        strOut = strOut & FmtVal(mVATRates(lngCounter), enftNumber, 5, 3)
    Next
    For lngCounter = 1 To 9 Step 1
        strOut = strOut & FmtVal(mVATSymbol(lngCounter), enftString, 1)
    Next
    For lngCounter = 1 To 9 Step 1
        strOut = strOut & FmtVal(mExVATValue(lngCounter), enftNumber, 8, 2)
    Next
    For lngCounter = 1 To 9 Step 1
        strOut = strOut & FmtVal(mVATValue(lngCounter), enftNumber, 8, 2)
    Next
    strOut = strOut & FmtVal(mTranParked, enftYesNo)
    strOut = strOut & FmtVal(mRefundManager, enftCode, 3)
    strOut = strOut & FmtVal(mTenderOverrideCode, enftCode, 2)
    strOut = strOut & FmtVal(mRecoveredFromParked, enftYesNo)
    strOut = strOut & FmtVal(mOffline, enftYesNo)
    strOut = strOut & FmtVal(oCashBO.Name, enftString, 22)
    strOut = strOut & FmtVal(oCashBO.SignOnCode, enftCode, 5)
    strOut = strOut & FmtVal(False, enftYesNo)
    strOut = strOut & FmtVal(mGiftTokensPrinted, enftNumber, 2)
    strOut = strOut & FmtVal(mColleagueCardNo, enftCode, 9)
    strOut = strOut & FmtVal("0", enftCode, 2) 'Added 24/8/07 - padding for Ux Import of SSTA
    strOut = strOut & FmtVal("0", enftCode, 4) 'Added 24/8/07 - padding for Ux Import of SSEQ
    strOut = strOut & FmtVal("", enftString, 8) 'Added 24/8/07 - padding for Ux Import of CBBU
    strOut = strOut & FmtVal(mDiscountCardNumber, enftCode, 19)

    GetFileLine = strOut
    
End Function

Private Function MissingEANs() As Collection

' Returns the payments (invoice tenders) for the invoice
Dim oRSelector  As IRowSelector
Dim oBoSortKeys As IBoSortKeys
    
    Debug.Assert LenB(mTransactionNo) <> 0
    Set oRSelector = m_oSession.Database.CreateBoSelector(CLASSID_POSMISSINGEAN)
    With m_oSession.Database
        Call oRSelector.Override(.CreateBoSelector(FID_POSMISSINGEAN_TransactionNumber, CMP_EQUAL, mTransactionNo))
        Call oRSelector.Override(.CreateBoSelector(FID_POSMISSINGEAN_TransactionDate, CMP_EQUAL, mTranDate))
        Call oRSelector.Override(.CreateBoSelector(FID_POSMISSINGEAN_TillID, CMP_EQUAL, mTillID))
    End With
    ' Order by sequence number within invoice
    Set oBoSortKeys = New CBoSortKeys
    oBoSortKeys.Add FID_POSMISSINGEAN_LineNumber
        
    Set MissingEANs = m_oSession.Database.GetSortedBoCollection(oRSelector, oBoSortKeys)

End Function

Private Function ReturnLines() As Collection

' Returns the payments (invoice tenders) for the invoice
Dim oRSelector  As IRowSelector
Dim oBoSortKeys As IBoSortKeys
    
    Debug.Assert LenB(mTransactionNo) <> 0
    Set oRSelector = m_oSession.Database.CreateBoSelector(CLASSID_RETURNCUST)
    With m_oSession.Database
        Call oRSelector.Override(.CreateBoSelector(FID_RETURNCUST_TransactionNumber, CMP_EQUAL, mTransactionNo))
        Call oRSelector.Override(.CreateBoSelector(FID_RETURNCUST_TransactionDate, CMP_EQUAL, mTranDate))
        Call oRSelector.Override(.CreateBoSelector(FID_RETURNCUST_PCTillID, CMP_EQUAL, mTillID))
    End With
    ' Order by sequence number within invoice
    Set oBoSortKeys = New CBoSortKeys
    oBoSortKeys.Add FID_RETURNCUST_LineNumber
        
    Set ReturnLines = m_oSession.Database.GetSortedBoCollection(oRSelector, oBoSortKeys)

End Function

'<CACH>****************************************************************************************
'* Function:  Boolean UpdateQuoteNumber()
'**********************************************************************************************
'* Description: Used to update the quote number ?
'**********************************************************************************************
'* Parameters:
'*In/Out:oRow   String. Quote Number
'**********************************************************************************************
'* Returns:  Boolean
'**********************************************************************************************
'* History:
'* 13/06/07    michaelo
'*             Header added.
'</CACH>***************************************************************************************

Public Function UpdateQuoteNumber(strQuoteNumber As String) As Boolean

Dim oRow     As Object 'list of fields to save
Dim blnSaved As Boolean
    
    Set oRow = m_oSession.Root.CreateUtilityObject("CRow")
    ' Identify row by the key
    Call oRow.Add(GetField(FID_POSHEADER_TranDate))
    Call oRow.Add(GetField(FID_POSHEADER_TillID))
    Call oRow.Add(GetField(FID_POSHEADER_TransactionNo))
   
    'Add the field that needs updating
    mOrderNumber = Format(strQuoteNumber, "000000")
    Call oRow.Add(GetField(FID_POSHEADER_OrderNumber))
        
    blnSaved = m_oSession.Database.SavePartialBo(Me, oRow)
    Debug.Assert blnSaved
    Set oRow = Nothing
    
    UpdateQuoteNumber = blnSaved

End Function



